﻿import TodoModel from './TodoModel.js';

describe('TodoModel', function() {
    describe('Can addTodo', function(){
        var store,
            model;

        beforeEach(function(){
            store = {};
            model = new TodoModel('test-todos');

            spyOn(localStorage, 'getItem').and.callFake(function (key){
                return store[key];
            });
            spyOn(localStorage, 'setItem').and.callFake(function (key, value){
                return store[key] = value + '';
            });
            spyOn(localStorage, 'clear').and.callFake(function () {
                store = {};
            });
        });

        it('handles null', function(){
            model.addTodo(null);

            expect(model.todos.length).toEqual(1);
            expect(model.todos[0].title).toBeNull();
        });

        it('adds a todo, duh!', function(){
            var model = new TodoModel('test-todos');
            model.addTodo('new todo');

            expect(model.todos.length).toEqual(1);
            expect(model.todos[0].title).toEqual('new todo');
        });
    })
})