﻿/// <binding BeforeBuild='webpack' />
/*
This file in the main entry point for defining Gulp tasks and using Gulp plugins.
Click here to learn more. http://go.microsoft.com/fwlink/?LinkId=518007
*/

var gulp = require('gulp');
var gutil = require('gulp-util');
var webpack = require('webpack');

gulp.task('webpack', function (callback) {
    // run webpack
    webpack({
        entry: [
          "./Scripts/app.js"
        ],
        output: {
            path: __dirname + '/build',
            filename: "bundle.js"
        },
        module: {
            loaders: [
                { test: /\.js?$/, loaders: ['babel'], exclude: /node_modules/ },
                { test: /\.js$/, exclude: /node_modules/, loader: 'babel-loader' },
                { test: /\.css$/, loader: "style!css" }
            ]
        },
        devtool: 'source-map'
    }, function (err, stats) {
        if (err) throw new gutil.PluginError('webpack', err);
        gutil.log('[webpack]', stats.toString({
            // output options   
        }));
        callback();
    });
});

gulp.task('test-gulp', function () {
    require('babel-core/register');
    var jasmine = require('gulp-jasmine');

    return gulp.src('./Scripts/**/*.spec.js').pipe(jasmine());
});

gulp.task('test-karma', function (callback) {
    var Server = require('karma').Server;
    new Server({
        configFile: __dirname + '/karma.conf.js',
        singleRun: true
    }, callback).start();
});