﻿using NUnit.Framework;
using System.Diagnostics;

namespace TestLifeCycle
{
    [TestFixture]
    public class TestClass : BaseClass
    {
        private object result = 3;

        [TestFixtureSetUp]
        public void ClassSetUp()
        {
            Trace.WriteLine(new string(' ', 2) + nameof(ClassSetUp));
        }

        [SetUp]
        public void TestSetup()
        {
            Trace.WriteLine(new string(' ', 6) + nameof(TestSetup));
        }

        [Test]
        public void TestA()
        {
            Trace.WriteLine(new string(' ', 8) + nameof(TestA));

            Assert.IsTrue(result is string);
        }

        [Test]
        public void TestB()
        {
            Trace.WriteLine(new string(' ', 8) + nameof(TestB));
            
            Assert.That(result, Is.InstanceOf<string>(), "Result should be a string");
        }
        
        [TearDown]
        public void TestTearDown()
        {
            Trace.WriteLine(new string(' ', 6) + nameof(TestTearDown));
        }

        [TestFixtureTearDown]
        public void ClassTearDown()
        {
            Trace.WriteLine(new string(' ', 2) + nameof(ClassTearDown));
        }
    }
}
